grammar LossGrammarNaked;

// Grammar
rules:         rule (';' rule )*;
rule:          target '->'  actions;
target:        aaclass ('/' range) ?;
actions:       action (',' action)*;
action:        (modifaction)+ | removalaction (modifaction)*;
modifaction:   '-' INT |'-' FLOAT ;
removalaction: 'del';
aaclass:       AA | '['  AA (AA)* ']';
range:         number  ':' number;
number:        INT | FLOAT;

// Lexers
INT:           '0'..'9'+ ;
FLOAT:         INT ('.' INT);
AA:            'A'..'Z' ;
WS:            (' '|'\t')+ {skip();} ;
